#include "date.h"

namespace xs { namespace date {

using panda::string;
using panda::string_view;

Date sv2date (const Sv& arg, const Timezone* zone, int fmt) {
    if (!arg) return Date(0, zone);
    if (!arg.defined()) return Date("!"); // date with parsing error

    if (SvROK(arg)) {
        SV* v = SvRV(arg);
        if (SvOBJECT(v)) {
            Object o = v;
            if (o.stash().name() == "Date") return *xs::in<Date*>(arg);
            return Date(xs::in<string_view>(arg), zone, fmt);
        }
        else throw "invalid date argument";
    }

    if (SvNIOK(arg) || arg.is_like_number()) {
        if (SvNOK(arg)) return Date((double)SvNV(arg), zone);
        return Date(xs::in<ptime_t>(arg), zone);
    }
    return Date(xs::in<string_view>(arg), zone, fmt);
}

DateRel sv2daterel (const Sv& arg) {
    if (!arg.defined()) return DateRel();

    if (arg.is_ref()) return *xs::in<const DateRel*>(arg);

    if (SvNIOK(arg) || arg.is_like_number()) return DateRel(0, 0, 0, 0, 0, xs::in<ptime_t>(arg));

    return DateRel(xs::in<string_view>(arg));
}

}}
